process vtSimpleWatch =
     { integer TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A, L_C, H_C; }
     ( )
   (| (| (J,H,M,S) := SimpleWatch(TOPS,ERESET)
       | CONTEXT{}
       | SCREEN{TICK_NUMBER,FRONT_NUMBER,TICK_HEIGHT,DELTA,TICK_WIDTH,ESP_HEIGHT,STRING_HEIGHT,MIN_A,MAX_A}
       | BACK{}
       |)/ VS, VM, VH, VJ, CS, HE, ERESET, TOPS, canvas, S, M, H, J |)
   where 
   use libGraphics; 
   TWindow canvas;
   event H_0, HE, TOPS, ERESET;
   process BACK =
        ( ? integer J;
            integer H;
            integer M;
            integer S;
          ! event HE;
            boolean CS;
            integer VJ;
            integer VH;
            integer VM;
            integer VS;
        )
      (| HE := ^S
       | CS := HE
       | VS := S
       | VM := M
       | VH := H
       | VJ := J
       |)
   ; 
   process CONTEXT =
        ( ! event H_0;
            event TOPS;
            event ERESET;
            TWindow canvas;
        )
      (| (| PACE_MAKER{}
          | (| H := HES
             | SCAN{}
             |) where event H; end
          | createWindows{}
          | HE := readClock()
          |)/ HE, butERESET, frame, HES |)
      where 
      process SCAN =
           ( ? event H;
               TWindow butERESET;
             ! event TOPS;
               event ERESET;
           )
         (| TOPS := when H
          | C_ERESET := readButton(butERESET)
          | ERESET := when C_ERESET
          |)
         where 
         boolean C_ERESET;
         end
      ; 
      function readClock =
           ( ! event HE;
           )
         pragmas 
            Java_CODE "&o1=true"
         end pragmas
      
      ; 
      process createWindows =
           ( ? TWindow frame;
               event H_0;
               event HE;
             ! TWindow butERESET;
               TWindow canvas;
           )
         (| fr := frame when H_0
          | P1 := createPanel(fr,#horiz)
          | P11 := createPanel(P1,#vertic)
          | L1 := createLabel(P11)
          | border := createBorder(P11,H_C/10,L_C/10)
          | L2 := createLabel(P11)
          | L3 := createLabel(P11)
          | L4 := createLabel(P11)
          | L5 := createLabel(P11)
          | border2 := createBorder(P11,L_C/10,0)
          | canvas := createCanvas(P1,H_C,L_C) cell HE
          | butERESET := createButton(fr) cell HE
          | L1 --> border
          | P11 --> canvas
          | canvas --> butERESET
          |)
         where 
         TWindow P1, P11, L1, L2, L3, L4, L5, fr;
         integer border, border2;
         end
      ; 
      event HES, HE;
      TWindow frame, butERESET;
      end
   ; 
   process SCREEN =
        { integer TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A; }
        ( ? event HE;
            boolean CS;
            integer VJ;
            integer VH;
            integer VM;
            integer VS;
            TWindow canvas;
        )
      (| (| X := WSET{TICK_NUMBER,FRONT_NUMBER,TICK_HEIGHT,DELTA+DELTA+TICK_WIDTH}(canvas,HE)
          | (| Z_VJ := VJ$ init MIN_A
             | WINT{(21*TICK_HEIGHT)+10,TICK_HEIGHT,DELTA,TICK_WIDTH,MIN_A,MAX_A,STRING_HEIGHT}(canvas,Z_VJ,VJ,X)
             |)/ Z_VJ
          | (| Z_VH := VH$ init MIN_A
             | WINT{(19*TICK_HEIGHT)+10,TICK_HEIGHT,DELTA,TICK_WIDTH,MIN_A,MAX_A,STRING_HEIGHT}(canvas,Z_VH,VH,X)
             |)/ Z_VH
          | (| Z_VM := VM$ init MIN_A
             | WINT{17*TICK_HEIGHT,TICK_HEIGHT,DELTA,TICK_WIDTH,MIN_A,MAX_A,STRING_HEIGHT}(canvas,Z_VM,VM,X)
             |)/ Z_VM
          | (| Z_VS := VS$ init MIN_A
             | WINT{15*TICK_HEIGHT,TICK_HEIGHT,DELTA,TICK_WIDTH,MIN_A,MAX_A,STRING_HEIGHT}(canvas,Z_VS,VS,X)
             |)/ Z_VS
          |)/ X |)
      where 
      constant TColor vc = black;
      process WSET =
           { integer XN, FN, DY, TS; }
           ( ? TWindow canvas;
               boolean HE;
             ! integer V;
           )
         (| (| V := ACCU_MOD{TS,TS*XN,TS*(FN-1)}(HE)
             | clearCanvas(canvas when (^V),V,(FN-1)*TS,H_C)
             |)/ V
          | V := ACCU_MOD{TS,TS*XN,TS*(XN-1)}(HE)
          |)
         where 
         process ACCU_MOD =
              { integer V_INC, V_BOUND, V_INIT; }
              ( ? boolean HE;
                ! integer V;
              )
            (| V ^= HE
             | ZV := V$ init V_INIT
             | V1 := ZV+V_INC
             | V := (0 when (V1>=V_BOUND)) default V1
             |)
            where 
            integer V1, ZV;
            end
         ; 
         end
      ; 
      process WBOOL =
           { integer Y_POS, BOOL_HEIGHT, DELTA, BOOL_WIDTH; }
           ( ? TWindow canvas;
               boolean C;
               integer X;
           )
         (| H := ^C
          | ECRAN := canvas when H
          | (| X0 := X when H
             | X1 := X0+DELTA
             | drawHorLine(ECRAN,X0,Y_POS,X1,vc)
             |)
          | (| Y2 := Y_POS+((BOOL_HEIGHT when C) default ((-BOOL_HEIGHT) when (not C)))
             | drawVertLine(ECRAN,X1,Y_POS,Y2,vc)
             | X2 := X1+BOOL_WIDTH
             | drawHorLine(ECRAN,X1,Y2,X2,vc)
             | drawVertLine(ECRAN,X2,Y_POS,Y2,vc)
             |)
          | drawHorLine(ECRAN,X2,Y_POS,X2+DELTA,vc)
          |)
         where 
         integer X0, X1, Y2, X2;
         TWindow ECRAN;
         event H;
         end
      ; 
      process WBOTTOM =
           { integer Y_POS, DELTA; }
           ( ? TWindow canvas;
               event H;
               integer X;
           )
         (| H_COMPL := when ((not H) default (^X))
          | ECRAN := canvas when H_COMPL
          | X1 := X when H_COMPL
          | drawHorLine(ECRAN,X1,Y_POS,X1+DELTA,vc)
          |)
         where 
         integer X1;
         TWindow ECRAN;
         event H_COMPL;
         end
      ; 
      process WINT =
           { integer Y_POS, HEIGHT, DELTA, WIDTH, C_min, C_max, STRING_HEIGHT; }
           ( ? TWindow canvas;
               integer C_ret;
               integer C;
               integer X;
           )
         (| H := ^C
          | ECRAN := canvas when H
          | X0 := X when H
          | diff := C_max-C_min
          | prop := real(diff/HEIGHT)
          | C_aff := (C when ((C<C_max) when (C>C_min))) default (C_max when (not (C<C_max))) default (C_min when (not (C>C_min)))
          | Y1_rel := real(C_aff-C_min)/prop
          | Y1 := integer(Y1_rel)
          | DX := WIDTH+(2*DELTA)
          | fillRect(ECRAN,X0,Y_POS-Y1,DX,Y1,vc)
          | drawInteger(ECRAN,C_aff,X0,Y_POS+STRING_HEIGHT)
          |)
         where 
         boolean chang;
         event H;
         TWindow ECRAN;
         integer X0, DX, Y1, diff, C_ret_aff, C_aff;
         real prop, Y0_rel, Y1_rel;
         end
      ; 
      integer X, Z_VJ, Z_VH, Z_VM, Z_VS;
      end
   ; 
   process SimpleWatch =
        ( ? event TOPS, ERESET;
          ! integer JOUR, HEURE, MINUTE, SECONDE;
        )
      (| (| VSECONDE ^= TOPS ^+ ERESET
          | RESET_SECONDE := ERESET ^+ NOUV_MINUTE
          | (VSECONDE,NOUV_MINUTE) := TOPMOD{60}(RESET_SECONDE)
          |)
       | (| VMINUTE ^= NOUV_MINUTE ^+ ERESET
          | RESET_MINUTE := ERESET ^+ NOUV_HEURE
          | (VMINUTE,NOUV_HEURE) := TOPMOD{60}(RESET_MINUTE)
          |)
       | (| VHEURE ^= NOUV_HEURE ^+ ERESET
          | RESET_HEURE := ERESET ^+ NOUV_JOUR
          | (VHEURE,NOUV_JOUR) := TOPMOD{24}(RESET_HEURE)
          |)
       | (| VJOUR ^= TOPS ^+ ERESET
          | ZJOUR := VJOUR$ init 0
          | VJOUR := (0 when ERESET) default ((ZJOUR+1) when NOUV_JOUR) default ZJOUR
          |)
       | (JOUR,HEURE,MINUTE,SECONDE) := AFFICHAGE{}(VJOUR,VHEURE,VMINUTE,VSECONDE,TOPS ^+ ERESET)
       |)
      where 
      event RESET_HEURE, RESET_SECONDE, RESET_MINUTE, RESET_JOUR, NOUV_JOUR, NOUV_HEURE, NOUV_MINUTE;
      integer ZJOUR, VJOUR, VHEURE, VMINUTE, VSECONDE;
      process AFFICHAGE =
           ( ? integer VJOUR, VHEURE, VMINUTE, VSECONDE;
               event TOPS;
             ! integer JOUR, HEURE, MINUTE, SECONDE;
           )
         (| SECONDE ^= MINUTE ^= HEURE ^= JOUR ^= TOPS
          | SECONDE := VSECONDE cell TOPS
          | MINUTE := VMINUTE cell TOPS
          | HEURE := VHEURE cell TOPS
          | JOUR := VJOUR cell TOPS
          |)
      ; 
      process TOPMOD =
           { integer V0; }
           ( ? event RESET;
             ! integer VCPT;
               event OEV;
           )
         (| ZVCPT := VCPT$ init V0
          | VCPT := (0 when RESET) default (ZVCPT+1)
          | OEV := when (ZVCPT>=V0)
          |)
         where 
         integer ZVCPT;
         end
      ; 
      end
   ; 
   integer J, H, M, S, VJ, VH, VM, VS;
   boolean CS;
   end
; 
